Index: /palm/trunk/SOURCE/init_grid.f90
===================================================================
--- /palm/trunk/SOURCE/init_grid.f90	(revision 3065)
+++ /palm/trunk/SOURCE/init_grid.f90	(revision 3066)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Bugfix in IF statement before error message
+! 
+! 3065 2018-06-12 07:03:02Z Giersch
 ! New vertical stretching mechanism introduced
 ! 
@@ -484,5 +487,5 @@
 !-- Allocation of arrays for stretching
     ALLOCATE( min_dz_stretch_level_end(number_stretch_level_start) )
-    
+
 !
 !-- Define the vertical grid levels
@@ -497,5 +500,6 @@
        ENDDO
 
-       IF ( ANY( min_dz_stretch_level_end > dz_stretch_level_end ) ) THEN
+       IF ( ANY( min_dz_stretch_level_end(1:number_stretch_level_start) >      &
+                 dz_stretch_level_end(1:number_stretch_level_start) ) ) THEN
              message_string= 'Eeach dz_stretch_level_end has to be larger ' // &
                              'than its corresponding value for &' //           &
@@ -619,5 +623,6 @@
        ENDDO
        
-       IF ( ANY( min_dz_stretch_level_end < dz_stretch_level_end ) ) THEN
+       IF ( ANY( min_dz_stretch_level_end (1:number_stretch_level_start) <     &
+                 dz_stretch_level_end(1:number_stretch_level_start) ) ) THEN
              message_string= 'Eeach dz_stretch_level_end has to be less ' //   &
                              'than its corresponding value for &' //           &
Index: /palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 3065)
+++ /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 3066)
@@ -28,4 +28,7 @@
 ! -----------------
 ! $Id$
+! Error message revised 
+! 
+! 3065 2018-06-12 07:03:02Z Giersch
 ! dz was replaced by dz(1), error message concerning vertical stretching was 
 ! added  
@@ -5113,5 +5116,5 @@
                                      'stretching is applied have to be ',      &
                                      'greater than ', zw(nzut)
-          CALL message( 'init_grid', 'PA0496', 1, 2, 0, 6, 0 )
+          CALL message( 'radiation_interaction_init', 'PA0496', 1, 2, 0, 6, 0 )
        ENDIF 
 !
Index: /palm/trunk/SOURCE/vertical_nesting_mod.f90
===================================================================
--- /palm/trunk/SOURCE/vertical_nesting_mod.f90	(revision 3065)
+++ /palm/trunk/SOURCE/vertical_nesting_mod.f90	(revision 3066)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! Error messages revised
+! 
+! 3065 2018-06-12 07:03:02Z Giersch
 ! dz was replaced by dz(1), error messages related to vertical grid stretching 
 ! have been added
@@ -3738,5 +3741,5 @@
                message_string = 'Stretching in the parent domain is '//        &
                                 'only allowed above the nested domain'
-               CALL message( 'vertical_nesting_mod', 'PA0497', 1, 2, 0, 6, 0 )
+               CALL message( 'vnest_init_pegrid_domain', 'PA0497', 1, 2, 0, 6, 0 )
            ENDIF
 
@@ -3976,5 +3979,5 @@
                    message_string = 'Stretching in the nested domain is not '//&
                            'allowed'
-                   CALL message( 'vertical_nesting_mod', 'PA0498', 1, 2, 0, 6, 0 )
+                   CALL message( 'vnest_init_grid', 'PA0498', 1, 2, 0, 6, 0 )
                 ENDIF
                 
Index: /palm/trunk/SOURCE/wind_turbine_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 3065)
+++ /palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 3066)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! Error message revised
+! 
+! 3065 2018-06-12 07:03:02Z Giersch
 ! dz was replaced by dz(1), error message concerning grid stretching has been
 ! introduced
@@ -1010,5 +1013,5 @@
                                      'greater than ', MAXVAL(rcz) +            &
                                       MAXVAL(rr) + eps_min
-          CALL message( 'init_grid', 'PA0484', 1, 2, 0, 6, 0 )
+          CALL message( 'wtm_init', 'PA0484', 1, 2, 0, 6, 0 )
        ENDIF 
 !