Index: /palm/trunk/SOURCE/netcdf_data_input_mod.f90
===================================================================
--- /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3088)
+++ /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3089)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Revise call for message routine in case of local data inconsistencies.
+! 
+! 3054 2018-06-01 16:08:59Z gronemeier
 ! Bugfix: force an MPI abort if errors occur while reading building heights
 ! from ASCII file
@@ -2880,5 +2883,5 @@
           message_string = 'NetCDF variable zt is not ' //                     &
                            'allowed to have missing data'
-          CALL message( 'netcdf_data_input_mod', 'NDI013', 2, 2, 0, 6, 0 )
+          CALL message( 'netcdf_data_input_mod', 'NDI013', 2, 2, myid, 6, 0 )
        ENDIF
 !
@@ -2931,10 +2934,10 @@
                 message_string = 'If vegegation_type = 0 at any location, ' // &
                                  'vegetation_pars is required'
-                CALL message( 'netcdf_data_input_mod', 'NDI017', 2, 2, 0, 6, 0 )
+                CALL message( 'netcdf_data_input_mod', 'NDI017', 2, 2, -1, 6, 0 )
              ENDIF
              IF ( .NOT. root_area_density_lsm_f%from_file )  THEN
                 message_string = 'If vegegation_type = 0 at any location, ' // &
                                  'root_area_dens_s is required'
-                CALL message( 'netcdf_data_input_mod', 'NDI018', 2, 2, 0, 6, 0 )
+                CALL message( 'netcdf_data_input_mod', 'NDI018', 2, 2, myid, 6, 0 )
              ENDIF
           ENDIF
@@ -2956,5 +2959,5 @@
              message_string = 'If soil_type = 0 at any location, ' //          &
                               'soil_pars is required'
-             CALL message( 'netcdf_data_input_mod', 'NDI019', 2, 2, 0, 6, 0 )
+             CALL message( 'netcdf_data_input_mod', 'NDI019', 2, 2, myid, 6, 0 )
           ENDIF
        ENDIF
@@ -2966,5 +2969,5 @@
                 message_string = 'If building_type = 0 at any location, ' //   &
                                  'building_pars is required'
-                CALL message( 'netcdf_data_input_mod', 'NDI020', 2, 2, 0, 6, 0 )
+                CALL message( 'netcdf_data_input_mod', 'NDI020', 2, 2, myid, 6, 0 )
              ENDIF
           ENDIF
@@ -2977,5 +2980,5 @@
                 message_string = 'If albedo_type = 0 at any location, ' //     &
                                  'albedo_pars is required'
-                CALL message( 'netcdf_data_input_mod', 'NDI021', 2, 2, 0, 6, 0 )
+                CALL message( 'netcdf_data_input_mod', 'NDI021', 2, 2, myid, 6, 0 )
              ENDIF
           ENDIF
@@ -2988,5 +2991,5 @@
                 message_string = 'If pavement_type = 0 at any location, ' //   &
                                  'pavement_pars is required'
-                CALL message( 'netcdf_data_input_mod', 'NDI022', 2, 2, 0, 6, 0 )
+                CALL message( 'netcdf_data_input_mod', 'NDI022', 2, 2, myid, 6, 0 )
              ENDIF
           ENDIF
@@ -3000,5 +3003,5 @@
                 message_string = 'If pavement_type = 0 at any location, ' //   &
                                  'pavement_subsurface_pars is required'
-                CALL message( 'netcdf_data_input_mod', 'NDI023', 2, 2, 0, 6, 0 )
+                CALL message( 'netcdf_data_input_mod', 'NDI023', 2, 2, myid, 6, 0 )
              ENDIF
           ENDIF
@@ -3011,5 +3014,5 @@
                 message_string = 'If water_type = 0 at any location, ' //      &
                                  'water_pars is required'
-                CALL message( 'netcdf_data_input_mod', 'NDI024', 2, 2, 0, 6, 0 )
+                CALL message( 'netcdf_data_input_mod', 'NDI024', 2, 2,myid, 6, 0 )
              ENDIF
           ENDIF
@@ -3031,5 +3034,5 @@
                                  'building_type, or water_type must be set '// &
                                  'to a non-missing value. Grid point: ', j, i
-                CALL message( 'netcdf_data_input_mod', 'NDI025', 2, 2, 0, 6, 0 )
+                CALL message( 'netcdf_data_input_mod', 'NDI025', 2, 2, myid, 6, 0 )
              ENDIF
 !
@@ -3052,5 +3055,5 @@
                                  'pavement_type is a non-missing value.'
                    CALL message( 'netcdf_data_input_mod', 'NDI026',            &
-                                  2, 2, 0, 6, 0 )
+                                  2, 2, myid, 6, 0 )
                 ENDIF
              ENDIF
@@ -3073,5 +3076,5 @@
                                  'must be provided.'
                    CALL message( 'netcdf_data_input_mod', 'NDI027',            &
-                                  2, 2, 0, 6, 0 )
+                                  2, 2, myid, 6, 0 )
                 ELSEIF ( ANY ( surface_fraction_f%frac(:,j,i) ==               &
                                surface_fraction_f%fill ) )  THEN
@@ -3080,5 +3083,5 @@
                                  'must be provided.'
                    CALL message( 'netcdf_data_input_mod', 'NDI027',            &
-                                  2, 2, 0, 6, 0 )
+                                  2, 2, myid, 6, 0 )
                 ENDIF
              ENDIF
@@ -3093,5 +3096,5 @@
                    message_string = 'surface_fraction must not exceed 1'
                    CALL message( 'netcdf_data_input_mod', 'NDI028',            &
-                                  2, 2, 0, 6, 0 )
+                                  2, 2, myid, 6, 0 )
                 ENDIF
 !
@@ -3119,5 +3122,5 @@
                              ' ), but surface fraction is 0 for the given type.'
                    CALL message( 'netcdf_data_input_mod', 'NDI029',            &
-                                  2, 2, 0, 6, 0 )
+                                  2, 2, myid, 6, 0 )
                 ENDIF
 !
@@ -3146,5 +3149,5 @@
                              'given type.'
                    CALL message( 'netcdf_data_input_mod', 'NDI030',            &
-                                  2, 2, 0, 6, 0 )
+                                  2, 2, myid, 6, 0 )
                 ENDIF
              ENDIF
@@ -3161,5 +3164,5 @@
                                        'this location must be set.'
                       CALL message( 'netcdf_data_input_mod', 'NDI031',         &
-                                     2, 2, 0, 6, 0 )
+                                     2, 2, myid, 6, 0 )
                    ENDIF
                 ENDIF
@@ -3176,5 +3179,5 @@
                                        'must be set at this location.'
                       CALL message( 'netcdf_data_input_mod', 'NDI032',         &
-                                     2, 2, 0, 6, 0 )
+                                     2, 2, myid, 6, 0 )
                    ENDIF
                 ENDIF
@@ -3200,5 +3203,5 @@
                                     'soil_pars at this location must be set.'
                    CALL message( 'netcdf_data_input_mod', 'NDI033',            &
-                                  2, 2, 0, 6, 0 )
+                                  2, 2, myid, 6, 0 )
                 ENDIF
              ENDIF
@@ -3215,5 +3218,5 @@
                                        'location must be set.'
                       CALL message( 'netcdf_data_input_mod', 'NDI034',         &
-                                     2, 2, 0, 6, 0 )
+                                     2, 2, myid, 6, 0 )
                    ENDIF
                 ENDIF
@@ -3232,5 +3235,5 @@
                                          'i, j = ', i, j
                       CALL message( 'netcdf_data_input_mod', 'NDI035',         &
-                                     2, 2, 0, 6, 0 )
+                                     2, 2, myid, 6, 0 )
                    ENDIF
                 ENDIF
@@ -3244,5 +3247,5 @@
                                          'i, j = ', i, j
                       CALL message( 'netcdf_data_input_mod', 'NDI035',         &
-                                     2, 2, 0, 6, 0 )
+                                     2, 2, myid, 6, 0 )
                    ENDIF
                 ENDIF
@@ -3259,5 +3262,5 @@
                                          '( and vice versa ). i, j = ', i, j
                       CALL message( 'netcdf_data_input_mod', 'NDI036',         &
-                                     2, 2, 0, 6, 0 )
+                                     2, 2, myid, 6, 0 )
                    ENDIF
                 ELSEIF ( buildings_f%lod == 2 )  THEN
@@ -3268,5 +3271,5 @@
                                          '( and vice versa ). i, j = ', i, j
                       CALL message( 'netcdf_data_input_mod', 'NDI036',         &
-                                     2, 2, 0, 6, 0 )
+                                     2, 2, myid, 6, 0 )
                    ENDIF
                 ENDIF
@@ -3282,5 +3285,5 @@
                                                  'requires an ID.', i, j
                       CALL message( 'netcdf_data_input_mod', 'NDI036',         &
-                                     2, 2, 0, 6, 0 )
+                                     2, 2, myid, 6, 0 )
                    ENDIF
                 ELSEIF ( buildings_f%lod == 2 )  THEN
@@ -3290,5 +3293,5 @@
                                                  'requires an ID.', i, j
                       CALL message( 'netcdf_data_input_mod', 'NDI036',         &
-                                     2, 2, 0, 6, 0 )
+                                     2, 2, myid, 6, 0 )
                    ENDIF
                 ENDIF
@@ -3305,5 +3308,5 @@
                                        'location must be set.'
                       CALL message( 'netcdf_data_input_mod', 'NDI037',         &
-                                     2, 2, 0, 6, 0 )
+                                     2, 2, myid, 6, 0 )
                    ENDIF
                 ENDIF
@@ -3321,5 +3324,5 @@
                                        'location must be set.'
                       CALL message( 'netcdf_data_input_mod', 'NDI038',         &
-                                     2, 2, 0, 6, 0 )
+                                     2, 2, myid, 6, 0 )
                    ENDIF
                 ENDIF
@@ -3338,5 +3341,5 @@
                                        'location must be set.'
                       CALL message( 'netcdf_data_input_mod', 'NDI039',         &
-                                     2, 2, 0, 6, 0 )
+                                     2, 2, myid, 6, 0 )
                    ENDIF
                 ENDIF
@@ -3354,5 +3357,5 @@
                                        'location must be set.'
                       CALL message( 'netcdf_data_input_mod', 'NDI040',         &
-                                     2, 2, 0, 6, 0 )
+                                     2, 2, myid, 6, 0 )
                    ENDIF
                 ENDIF