Index: palm/trunk/SOURCE/pmc_particle_interface.f90
===================================================================
--- palm/trunk/SOURCE/pmc_particle_interface.f90	(revision 3122)
+++ palm/trunk/SOURCE/pmc_particle_interface.f90	(revision 3123)
@@ -26,4 +26,7 @@
 ! -----------------! 
 ! $Id$
+! Correct working precision for REAL numbers
+! 
+! 3049 2018-05-29 13:52:36Z Giersch
 ! Error messages revised
 ! 
@@ -986,13 +989,13 @@
     INTEGER(iwp) ::  n    !< loop index (number of particles)
     
-    REAL(iwp) ::  x       !< x coordinate
-    REAL(iwp) ::  xo      !< x origin
-    REAL(iwp) ::  x_left  !< absolute left boundary
-    REAL(iwp) ::  x_right !< absolute right boundary
-    REAL(iwp) ::  y       !< left boundary in coarse(parent) index space
-    REAL(iwp) ::  yo      !< y origin
-    REAL(iwp) ::  y_north !< absolute north boundary
-    REAL(iwp) ::  y_south !< absoulte south boundary
-    REAL(iwp) ::  z       !< z coordinate
+    REAL(wp) ::  x       !< x coordinate
+    REAL(wp) ::  xo      !< x origin
+    REAL(wp) ::  x_left  !< absolute left boundary
+    REAL(wp) ::  x_right !< absolute right boundary
+    REAL(wp) ::  y       !< left boundary in coarse(parent) index space
+    REAL(wp) ::  yo      !< y origin
+    REAL(wp) ::  y_north !< absolute north boundary
+    REAL(wp) ::  y_south !< absoulte south boundary
+    REAL(wp) ::  z       !< z coordinate
 
 #if defined( __parallel )
@@ -1097,9 +1100,9 @@
     INTEGER(iwp) ::  pindex !< short variable name part_adr
     
-    REAL(iwp) ::  x  !< x coordinate
-    REAL(iwp) ::  xo !< x origin
-    REAL(iwp) ::  y  !< y coordinate
-    REAL(iwp) ::  yo !< y origin
-    REAL(iwp) ::  z  !< z coordinate
+    REAL(wp) ::  x  !< x coordinate
+    REAL(wp) ::  xo !< x origin
+    REAL(wp) ::  y  !< y coordinate
+    REAL(wp) ::  yo !< y origin
+    REAL(wp) ::  z  !< z coordinate
     
     INTEGER(iwp),DIMENSION(1) ::  buf_shape !<
Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 3122)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 3123)
@@ -28,4 +28,7 @@
 ! -----------------
 ! $Id$
+! Correct working precision for INTEGER number
+! 
+! 3122 2018-07-11 21:46:41Z maronga
 ! Bugfix: maximum distance for raytracing was set to  -999 m by default,
 ! effectively switching off all surface reflections when max_raytracing_dist
@@ -758,5 +761,5 @@
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  pch              !< heights of the plant canopy
     INTEGER(iwp)                                   ::  npcbl = 0        !< number of the plant canopy gridboxes in local processor
-    INTEGER(wp), DIMENSION(:,:), ALLOCATABLE       ::  pcbl             !< k,j,i coordinates of l-th local plant canopy box pcbl[:,l] = [k, j, i]
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  pcbl             !< k,j,i coordinates of l-th local plant canopy box pcbl[:,l] = [k, j, i]
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  pcbinsw          !< array of absorbed sw radiation for local plant canopy box
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  pcbinswdir       !< array of absorbed direct sw radiation for local plant canopy box
Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3122)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3123)
@@ -28,4 +28,7 @@
 ! -----------------
 ! $Id$
+! Correct working precision for INTEGER number
+! 
+! 3115 2018-07-10 12:49:26Z suehring
 ! Additional building type to represent bridges 
 ! 
@@ -586,5 +589,5 @@
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE        ::  aheat             !< daily average of anthropogenic heat (W/m2)
     REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  aheatprof         !< diurnal profiles of anthropogenic heat for particular layers
-    INTEGER(wp)                                    ::  naheatlayers = 1  !< number of layers of anthropogenic heat
+    INTEGER(iwp)                                   ::  naheatlayers = 1  !< number of layers of anthropogenic heat
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!